local _M = loadPrevious(...)

local old_init = _M.init
function _M:init(title, actor, filter, action, on_select)
	old_init(self, title, actor, filter, action, on_select)

	self.current_set = self.actor.off_weapon_slots
	self.actor:attr("quick_weapon_swap", 1)
end

local old_unload = _M.unload
function _M:unload()
	if self.actor.off_weapon_slots ~= self.current_set then self.actor:quickSwitchWeapons() end
	self.actor:attr("quick_weapon_swap", -1)

	old_unload(self)
end

function _M:switchSets(which)
	if which == "main" and not self.actor.off_weapon_slots then return end
	if which == "off" and self.actor.off_weapon_slots then return end

	local playSound = game.playSound
	game.playSound = function () end
	
	self.actor:quickSwitchWeapons(true)
	
	game.playSound = playSound

	self.c_main_set.selected = not self.actor.off_weapon_slots
	self.c_off_set.selected = self.actor.off_weapon_slots
end

return _M